<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__pdmpcm" kind="group">
    <compoundname>group_hal_pdmpcm</compoundname>
    <title>PDM/PCM (Pulse-Density Modulation to Pulse-Code Modulation Converter)</title>
    <innerclass prot="public" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</innerclass>
    <innergroup refid="group__group__hal__results__pdmpcm">PDM/PCM HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_pdm_pcm_event_t</name>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a23cdac0a9d48999fd992d2b6ec0c6d46" prot="public">
          <name>CYHAL_PDM_PCM_RX_HALF_FULL</name>
          <initializer>= 0x01</initializer>
          <briefdescription>
<para>RX hardware buffer is half full. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a7d033c3845dfddec84d445d36dfc6cd1" prot="public">
          <name>CYHAL_PDM_PCM_RX_NOT_EMPTY</name>
          <initializer>= 0x02</initializer>
          <briefdescription>
<para>RX hardware buffer is not empty. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a1f4fabcea8eab0bcaa83e790bc9bf9d7" prot="public">
          <name>CYHAL_PDM_PCM_RX_OVERFLOW</name>
          <initializer>= 0x04</initializer>
          <briefdescription>
<para>Attempt to write to a full RX hardware buffer. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a96b6aab4d2062870825335c3eb08ce7d" prot="public">
          <name>CYHAL_PDM_PCM_RX_UNDERFLOW</name>
          <initializer>= 0x08</initializer>
          <briefdescription>
<para>Attempt to read from an empty buffer. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc" prot="public">
          <name>CYHAL_PDM_PCM_ASYNC_COMPLETE</name>
          <initializer>= 0x10</initializer>
          <briefdescription>
<para>Async operation completed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_pdm_pcm_event_t: </bold><linebreak />PDM/PCM interrupt triggers.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="121" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="115" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="115" />
      </memberdef>
      <memberdef id="group__group__hal__pdmpcm_1gac81a68ee166ff48752095f82e6852565" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_pdm_pcm_mode_t</name>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a9b6dc0fbdb5ff94c50d3ea447b2e7729" prot="public">
          <name>CYHAL_PDM_PCM_MODE_LEFT</name>
          <briefdescription>
<para>The channel mono left. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a10f63e46718c10aefbc64bfda8b82cfd" prot="public">
          <name>CYHAL_PDM_PCM_MODE_RIGHT</name>
          <briefdescription>
<para>The channel mono right. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a3422b29a54a23f1133a62c2b566196dc" prot="public">
          <name>CYHAL_PDM_PCM_MODE_STEREO</name>
          <briefdescription>
<para>The channel stereo. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_pdm_pcm_mode_t: </bold><linebreak />PDM/PCM channel select.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="128" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="124" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="124" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_pdm_pcm_event_callback_t) (void *handler_arg, cyhal_pdm_pcm_event_t event)</definition>
        <argsstring>)(void *handler_arg, cyhal_pdm_pcm_event_t event)</argsstring>
        <name>cyhal_pdm_pcm_event_callback_t</name>
        <briefdescription>
<para>Handler for PDM/PCM interrupts. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" bodystart="142" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="142" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gac2baa0d5162498463cc5228e0ab70909" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_init</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_gpio_t pin_data, cyhal_gpio_t pin_clk, const cyhal_clock_t *clk_source, const cyhal_pdm_pcm_cfg_t *cfg)</argsstring>
        <name>cyhal_pdm_pcm_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin_data</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin_clk</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk_source</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Initialize the PDM/PCM peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>Configures the pins used by PDM/PCM converter, sets a default format and frequency, and enables the peripheral <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a PDM/PCM object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for PDM input </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin_clk</parametername>
</parameternamelist>
<parameterdescription>
<para>The pin to use for PDM clock output </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk_source</parametername>
</parameternamelist>
<parameterdescription>
<para>The clock source for PDM/PCM block </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>The configuration for the PDM/PCM block </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="534" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="446" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="155" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga89ce18cbdd29884ea093ea413df76c6f" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_free</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Release a PDM/PCM object, behavior is undefined if an asynchronous read is in progress. </para>        </briefdescription>
        <detaileddescription>
<para>Return the peripheral, pins and clock owned by the PDM/PCM object to their reset state <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to deinitialize </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="558" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="536" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="163" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_start</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_start</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Start the PDM/PCM operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to start </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the status of the start request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="575" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="560" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="171" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gae3832916c19f3031dddcee394047e499" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_stop</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_stop</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Stop the PDM/PCM operation. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to start </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>the status of the stop request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="582" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="577" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="179" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga70af22e5c029ef0899d14da93253fcc1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_pdm_pcm_is_enabled</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_is_enabled</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if the specified PDM/PCM peripheral is enabled (regardless of whether any unread data has been received). </para>        </briefdescription>
        <detaileddescription>
<para>The PDM/PCM peripheral can be enabled by calling <ref kindref="member" refid="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61">cyhal_pdm_pcm_start</ref> and disabled by calling <ref kindref="member" refid="group__group__hal__pdmpcm_1gae3832916c19f3031dddcee394047e499">cyhal_pdm_pcm_stop</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The I2S peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Whether the I2S receive function is enabled. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="588" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="584" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="190" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gad2dc5543b500a97a938d6c642932e772" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_set_gain</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, int8_t gain_left, int8_t gain_right)</argsstring>
        <name>cyhal_pdm_pcm_set_gain</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>int8_t</type>
          <declname>gain_left</declname>
        </param>
        <param>
          <type>int8_t</type>
          <declname>gain_right</declname>
        </param>
        <briefdescription>
<para>Updates the PDM/PCM channel gains. </para>        </briefdescription>
        <detaileddescription>
<para>Each integer increment represent a 0.5 dB value. For example: a gain value of 5 would mean +2.5 dB. If the exact gain value requested is not supported, it will be rounded to the nearest legal value. See the implementation specific documentation for valid ranges.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Gains may be negative if the implementation supports it.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object to configure </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gain_left</parametername>
</parameternamelist>
<parameterdescription>
<para>The gain of the left channel in units of 0.5 dB </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">gain_right</parametername>
</parameternamelist>
<parameterdescription>
<para>The gain of the right channel in units of 0.5 dB </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set gain operation. An error will be returned if the value is outside of range supported by HW. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="601" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="590" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="204" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga4f6559e37a2ea3facdffe3cac6241356" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_clear</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_clear</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Clears the hardware buffer. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the clear request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="608" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="603" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="211" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga5694092b3f4bc66a0a649829d346d1c7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_read</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, void *data, size_t *length)</argsstring>
        <name>cyhal_pdm_pcm_read</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t *</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Reads data synchronously. </para>        </briefdescription>
        <detaileddescription>
<para>This will read either length words or the number of words that are currently available in the receive buffer, whichever is less, then return. The value pointed to by length will be updated to reflect the number of words that were actually read. If there are less data in FIFO than length, length will be update with number of words read.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to word array where incoming data will be stored. Buffer must be aligned to word-size. Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bits. Negative value will use sign-extension. -1 with 24-bit word length will have 32-bit value of 0xFFFFFFFF. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="inout">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of 32-bit words to read, updated with the number actually read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="641" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="610" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="228" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_read_async</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, void *data, size_t length)</argsstring>
        <name>cyhal_pdm_pcm_read_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>data</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>length</declname>
        </param>
        <briefdescription>
<para>Begin asynchronous PDM/PCM read. </para>        </briefdescription>
        <detaileddescription>
<para>This will transfer length words into the buffer pointed to by data in the background. When the requested quantity of data has been read, the <ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc">CYHAL_PDM_PCM_ASYNC_COMPLETE</ref> event will be raised. See <ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref> and <ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref>.</para><para>cyhal_pdm_pcm_set_async_mode can be used to control whether this uses DMA or a CPU-driven transfer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">data</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to word array where incoming data will be stored. Buffer must be aligned to word-size. Each word will be aligned to the next largest power of 2. For example, if the word length is 16 bits, each word will consume two bytes. But if the word length is 20, each word will consume 32 bits. Negative value will use sign-extension. -1 with 24-bit word length will have 32-bit value of 0xFFFFFFFF. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">length</parametername>
</parameternamelist>
<parameterdescription>
<para>Number of words to read </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="697" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="643" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="246" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga9510e6cfe34d3279aaa2fcf015e24288" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>bool</type>
        <definition>bool cyhal_pdm_pcm_is_pending</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_is_pending</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Checks if an async read operation is pending. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral to check </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>Indication of whether a PDM/PCM async operation is pending </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="703" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="699" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="253" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga5db8d3906cdd3cd0e2cadcb6a283d910" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_abort_async</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj)</argsstring>
        <name>cyhal_pdm_pcm_abort_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Abort an PDM/PCM operation started by cyhal_pdm_pcm_read_async function. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM peripheral to stop </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the abort_async request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="718" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="705" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="260" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_register_callback</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_pdm_pcm_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_pdm_pcm_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pdmpcm_1gac01795c2aaebf0b8c73bb6d82c4be198">cyhal_pdm_pcm_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register a PDM/PCM event handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt fires </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="726" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="720" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="270" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_pdm_pcm_enable_event</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_pdm_pcm_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_pdm_pcm_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure PDM/PCM event enablement. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on events, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="755" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="728" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="279" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__pdmpcm_1ga2296229eed2643ba0a938c3437c6ce82" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_pdm_pcm_set_async_mode</definition>
        <argsstring>(cyhal_pdm_pcm_t *obj, cyhal_async_mode_t mode, uint8_t dma_priority)</argsstring>
        <name>cyhal_pdm_pcm_set_async_mode</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1gab2d2acfb82599df54152be0b170c6ec2">cyhal_async_mode_t</ref></type>
          <declname>mode</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>dma_priority</declname>
        </param>
        <briefdescription>
<para>Set the mechanism that is used to perform PDM/PCM asynchronous operation. </para>        </briefdescription>
        <detaileddescription>
<para>The default is SW.</para><para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The PDM/PCM object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>The transfer mode </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dma_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority, if DMA is used. Valid values are the same as for <ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>. If DMA is not selected, the only valid value is CYHAL_DMA_PRIORITY_DEFAULT, and no guarantees are made about prioritization. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set mode request </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="783" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_pdmpcm.c" bodystart="757" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_pdmpcm.h" line="292" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para><linebreak />
</para><para>High level interface for interacting with the pulse-density modulation to pulse-code modulation (PDM/PCM) converter. </para>    </briefdescription>
    <detaileddescription>
<para>The PDM/PCM converter is a asynchronous operation. A PDM-PCM converter is used to convert 1-bit digital audio streaming data to PCM data. The sample rate, word size, and channels can all be configured.</para>
<para><heading level="1">Features</heading></para>
<para><itemizedlist>
<listitem><para>Supports FIFO buffer for Incoming Data</para></listitem><listitem><para>Configurable Gain Settings</para></listitem><listitem><para>Configurable Word Length</para></listitem><listitem><para>Configurable interrupt and callback assignment from PDM/PCM events - <ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref></para></listitem></itemizedlist>
</para>

<para><heading level="1">Quick Start</heading></para>
<para>Initialize a PDM/PCM converter instance using the <ref kindref="member" refid="group__group__hal__pdmpcm_1gac2baa0d5162498463cc5228e0ab70909">cyhal_pdm_pcm_init</ref> and provide the clock and data pins.<linebreak />
 See <ref kindref="member" refid="group__group__hal__pdmpcm_1subsection_pdmpcm_snippet_1">Snippet 1: PDM/PCM Initialization and Configuration</ref> for example initialization. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The clock parameter (const &lt;a href="structcyhal__clock__t.html#"&gt;cyhal_clock_t&lt;/a&gt; *clk) is optional and can be set to NULL to generate and use an available clock resource with a default frequency.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Code Snippets</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Error checking is omitted for clarity&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Snippet 1: PDM/PCM Initialization and Configuration</bold></para>
<para>This snippet initializes a PCM/PCM resource for conversion and assigns the pins.</para><para><programlisting filename="pdmpcm.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />pdm_pcm;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__cfg__t">cyhal_pdm_pcm_cfg_t</ref><sp />cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.sample_rate<sp />=<sp />44000,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.decimation_rate<sp />=<sp />10,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.mode<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggac81a68ee166ff48752095f82e6852565a3422b29a54a23f1133a62c2b566196dc">CYHAL_PDM_PCM_MODE_STEREO</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.word_length<sp />=<sp />16,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.left_gain<sp />=<sp />1,<sp /></highlight><highlight class="comment">/*<sp />+0.5<sp />db<sp />gain<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.right_gain<sp />=<sp />-2,<sp /></highlight><highlight class="comment">/*<sp />-1.0<sp />db<sp />gain<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac2baa0d5162498463cc5228e0ab70909">cyhal_pdm_pcm_init</ref>(&amp;pdm_pcm,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51aad04d2399d62b5af8c88438d56ddf99b">P0_5</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a8f9331cecf3c8f1bf81bc66386c8b4c1">P0_4</ref>,<sp />NULL,<sp />&amp;cfg);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />the<sp />PDM/PCM<sp />instance<sp />is<sp />no<sp />longer<sp />required,<sp />free<sp />it<sp />to<sp />release<sp />resources<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga89ce18cbdd29884ea093ea413df76c6f">cyhal_pdm_pcm_free</ref>(&amp;pdm_pcm);</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: PDM/PCM Asynchronous Receive</bold></para>
<para>This snippet shows how to receive data in the background using <ref kindref="member" refid="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031">cyhal_pdm_pcm_read_async</ref>. Notification of the asynchronous read completion is achieved by using <ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref> to register a callback function and <ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref> to enable callling the callback when an synchonous read completes.</para><para><programlisting filename="pdmpcm.c"><codeline><highlight class="comment">/*<sp />We<sp />use<sp />a<sp />dual<sp />buffer<sp />system<sp />so<sp />that<sp />one<sp />buffer<sp />can<sp />be<sp />filling<sp />while<sp />the<sp />other<sp />is<sp />being<sp />processed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />BUFFER_SIZE<sp />128u</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />rx_buffer0[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />rx_buffer1[BUFFER_SIZE];</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />*active_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />*full_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />pdm_pcm_event_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gae66c80c5bbcd3bb7bcfea6821fd009b7">cyhal_pdm_pcm_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />When<sp />we<sp />registered<sp />the<sp />callback,<sp />we<sp />set<sp />'arg'<sp />to<sp />point<sp />to<sp />the<sp />pdm_pcm<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*pdm_pcm<sp />=<sp />(<ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />*)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc">CYHAL_PDM_PCM_ASYNC_COMPLETE</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Flip<sp />the<sp />active<sp />and<sp />the<sp />next<sp />rx<sp />buffers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />*temp<sp />=<sp />active_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />active_rx_buffer<sp />=<sp />full_rx_buffer;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />full_rx_buffer<sp />=<sp />temp;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Start<sp />reading<sp />into<sp />the<sp />next<sp />buffer<sp />while<sp />the<sp />just-filled<sp />one<sp />is<sp />being<sp />processed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031">cyhal_pdm_pcm_read_async</ref>(pdm_pcm,<sp />active_rx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Process<sp />the<sp />data<sp />in<sp />the<sp />full_rx_buffer<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_pdm_pcm_async_receive(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__pdm__pcm__t">cyhal_pdm_pcm_t</ref><sp />pdm_pcm;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />object<sp />as<sp />shown<sp />in<sp />Snippet<sp />1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />PDM/PCM<sp />object,</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />from<sp />the<sp />callback<sp />handler.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga788431478c16508839c16bcd76681dac">cyhal_pdm_pcm_register_callback</ref>(&amp;pdm_pcm,<sp />&amp;pdm_pcm_event_handler,<sp />&amp;pdm_pcm);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />async<sp />complete<sp />event<sp />so<sp />that<sp />we<sp />can<sp />queue<sp />up<sp />another<sp />transfer<sp />when<sp />this<sp />one<sp />completes<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gac32c975ba7bd470359c0e235bcdd82e7">cyhal_pdm_pcm_enable_event</ref>(&amp;pdm_pcm,<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ggae66c80c5bbcd3bb7bcfea6821fd009b7a614d379497b9b51176dd7fedee414fdc">CYHAL_PDM_PCM_ASYNC_COMPLETE</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />asynchronous<sp />transfers<sp />to<sp />use<sp />DMA<sp />to<sp />free<sp />up<sp />the<sp />CPU<sp />during<sp />transfers<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1ga2296229eed2643ba0a938c3437c6ce82">cyhal_pdm_pcm_set_async_mode</ref>(&amp;pdm_pcm,<sp /><ref kindref="member" refid="group__group__hal__general__types_1ggab2d2acfb82599df54152be0b170c6ec2a580896db2028c77f9f89cb8772a1eb90">CYHAL_ASYNC_DMA</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__dma_1ga81946da56dd6ba8afd28f6056b1d779a">CYHAL_DMA_PRIORITY_DEFAULT</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref><sp />==<sp />result);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />active_rx_buffer<sp />=<sp />rx_buffer0;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />full_rx_buffer<sp />=<sp />rx_buffer1;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gab67389b3ca9173afb980824564dba031">cyhal_pdm_pcm_read_async</ref>(&amp;pdm_pcm,<sp />active_rx_buffer,<sp />BUFFER_SIZE);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />result<sp />=<sp /><ref kindref="member" refid="group__group__hal__pdmpcm_1gabbab5aafb181de83230b834074994b61">cyhal_pdm_pcm_start</ref>(&amp;pdm_pcm);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para><bold>Code examples (Github)</bold><itemizedlist>
<listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-pdm-pcm"> PSoC 6 MCU: PDM-to-PCM</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/mtb-example-psoc6-pdm-to-i2s"> PSoC 6 MCU: PDM to I2S</ulink> </para></listitem></itemizedlist>
</para>
    </detaileddescription>
  </compounddef>
</doxygen>